weatherStation/api/urls.py
from django.urls import path,include
from . import views
urlpatterns = [

]

weatherStation/door/urls.py
from django.urls import path,include
from . import views
app_name='door'
urlpatterns = [
    path('index/', views.index , name='index'),
    path('weatherTable/', views.weatherTable , name='weatherTable'),
    path('setCookie/<str:key>/<str:value>', views.setCookie , name='setCookie'),
    path('getCookie/<str:key>', views.getCookie , name='getCookie'),
    path('getAllCookies/', views.getAllCookies , name='getAllCookies'),

]

weatherStation/weatherStation/urls.py
from django.contrib import admin
from django.urls import path,include
from django.http import HttpResponseRedirect
urlpatterns = [
    path('', lambda r: HttpResponseRedirect('door/index/')),
    path('admin/', admin.site.urls),
    path('door/',include('door.urls')),
    path('api/',include('api.urls')),
    path('accounts/', include('django.contrib.auth.urls')), # 新增
]

weatherStation/api/models.py
from django.db import models
from datetime import datetime
# Create your models here.
class Record(models.Model):
    id = models.AutoField(primary_key=True)
    searchTime = models.DateTimeField(default=datetime.now)
    weather = models.CharField(max_length=256,default=None,blank=True, null=True)
    cityName = models.CharField(max_length=256,default=None,blank=True, null=True)
    degree = models.FloatField(default=0.0, blank=True, null=True)
    country = models.CharField(max_length=256,default=None, blank=True, null=True)

weatherStation/door/models.py
from django.db import models

# Create your models here.

weatherStation/api/views.py
from django.shortcuts import render

# Create your views here.

weatherStation/door/views.py
from django.shortcuts import render, redirect, get_object_or_404


from api.models import *
import requests, json,datetime
from django.conf import settings
from django.http import HttpResponse
from django.contrib.auth.decorators import login_required
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger  # pagination
###gabor
def setDefaulCookies(request):
    response = render(request, 'index.html')
    tomorrow = datetime.datetime.now() + datetime.timedelta(days=1)
    tomorrow = datetime.datetime.replace(tomorrow, hour=0, minute=0, second=0)
    expires = datetime.datetime.strftime(tomorrow, "%a, %d-%b-%Y %H:%M:%S GMT")

    response.set_cookie("4", request.COOKIES.get("3", None), expires=expires)
    response.set_cookie("3", request.COOKIES.get("2", None), expires=expires)
    response.set_cookie("2", request.COOKIES.get("1", None), expires=expires)
    response.set_cookie("1", request.COOKIES.get("0", None), expires=expires)
    response.set_cookie("0", request.COOKIES.get("5", None), expires=expires)
    return response
def sortCookies(request):
    #01234
    response = render(request, 'index.html')
    tomorrow = datetime.datetime.now() + datetime.timedelta(days=1)
    tomorrow = datetime.datetime.replace(tomorrow, hour=0, minute=0, second=0)
    expires = datetime.datetime.strftime(tomorrow, "%a, %d-%b-%Y %H:%M:%S GMT")
    if "5" in request.COOKIES.keys():
        response.set_cookie("4", request.COOKIES.get("3", None), expires=expires)
        response.set_cookie("3", request.COOKIES.get("2", None), expires=expires)
        response.set_cookie("2", request.COOKIES.get("1", None), expires=expires)
        response.set_cookie("1", request.COOKIES.get("0", None), expires=expires)
        response.set_cookie("0", request.COOKIES.get("5", None), expires=expires)
        response.delete_cookie('5')
    return response

# Create your views here.
def getPagedRecords(request):
    limit = 8
    records = Record.objects.all().order_by('-searchTime')
    paginator = Paginator(records, limit)

    page = request.GET.get('page')
    try:
        records = paginator.page(page)
    except PageNotAnInteger:
        records = paginator.page(1)
    except EmptyPage:
        records = paginator.page(paginator.num_pages)

    return records
def index_t(request):
    response = render(request, 'index.html')
    response.set_cookie('my_cookie', 'Here is my cookie!')
    return response

def index(request):
    query = Record.objects.all().order_by('-searchTime')[:5]
    context={"query":query,"cookie0":request.COOKIES.get("0", None),"cookie1":request.COOKIES.get("1", None),
                      "cookie2":request.COOKIES.get("2", None),"cookie3":request.COOKIES.get("3", None),"cookie4":request.COOKIES.get("4", None)}
    #sortCookies(request)
    #context={"cookie0":request.COOKIES['0'],"cookie1":request.COOKIES['1'],"cookie2":request.COOKIES['2'],"cookie3":request.COOKIES['3'],"cookie4":request.COOKIES['4']}
    if request.method == "POST":
        allData = request.POST
        cityName = allData['cityName']
        url = settings.API_URL+cityName+"&appid="+settings.APP_ID
        print('request url: '+url)
        request_api = requests.get(url)
        if request_api.status_code == 200:
            json_data = json.loads(request_api.text)
            cityName = json_data['name']
            country = json_data['sys']['country']
            degree = round(float(json_data['main']['temp']) - 273.15,2)
            weather = json_data['weather'][0]['main']
            record = Record.objects.create(cityName=cityName, country=country,weather=weather, degree=degree)
            context = {'record': record, "query": query,"cookie0":record.cityName,"cookie1":request.COOKIES.get("0", None),
                      "cookie2":request.COOKIES.get("1", None),"cookie3":request.COOKIES.get("2", None),"cookie4":request.COOKIES.get("3", None)}
            print(request_api.text)
            #setCookie(request,str(record.id), record.cityName)
            tomorrow = datetime.datetime.now() + datetime.timedelta(days=1)
            tomorrow = datetime.datetime.replace(tomorrow, hour=0, minute=0, second=0)
            expires = datetime.datetime.strftime(tomorrow, "%a, %d-%b-%Y %H:%M:%S GMT")

            response = render(request,'index.html',context)


            response.set_cookie("4", request.COOKIES.get("3", None), expires=expires)
            response.set_cookie("3", request.COOKIES.get("2", None), expires=expires)
            response.set_cookie("2", request.COOKIES.get("1", None), expires=expires)
            response.set_cookie("1", request.COOKIES.get("0", None), expires=expires)
            response.set_cookie("0", record.cityName, expires=expires)
            #context= {'record': record, "query": query,"cookie0":record.cityName,"cookie1":request.COOKIES.get("0", None),"cookie2":request.COOKIES.get("1", None),"cookie3":request.COOKIES.get("2", None),"cookie4":request.COOKIES.get("3", None)}
            #response = render(request, 'index.html', context)
            return response


        else:
            print('not found')
            context = {'noResult': 'result not found, please input again!',"query":query,"query":query,"cookie0":request.COOKIES.get("0", None),"cookie1":request.COOKIES.get("1", None),
                      "cookie2":request.COOKIES.get("2", None),"cookie3":request.COOKIES.get("3", None),"cookie4":request.COOKIES.get("4", None)}

    return render(request, 'index.html',context)
@login_required
def weatherTable(request):
    records = getPagedRecords(request)
    context = {'records':records}
    return render(request,'weatherTable.html',context)


def setCookie(request, key=None, value=None):  # 定義set_cookie函式，key為名稱，value為內容
    tomorrow = datetime.datetime.now() + datetime.timedelta(days=1)
    tomorrow = datetime.datetime.replace(tomorrow, hour=0, minute=0, second=0)
    expires = datetime.datetime.strftime(tomorrow, "%a, %d-%b-%Y %H:%M:%S GMT")
    response = HttpResponse('Cookie 儲存完畢')
    response.set_cookie(key, value,expires=expires)
    print('cookie: '+str(getCookie(request,key)))
    return response


def getCookie(request, key=None):
    if key in request.COOKIES:  # 檢查指定的Cookie是否存在
        return HttpResponse('%s:%s' % (key, request.COOKIES[key]))
        #return str(request.COOKIES[key])
    else:
        return HttpResponse('Cookie 不存在!')
def getAllCookies(request):
    if request.COOKIES != None:
        strcookies=""
        for key1,value1 in request.COOKIES.items():
            strcookies= strcookies + key1 + ":" + value1 + "<br>"
        return HttpResponse("%s" % (strcookies))
    else:
        return HttpResponse('Cookie 不存在!')
###avl

weatherStation/door/templates/index.html
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="//rawgithub.com/stidges/jquery-searchable/master/dist/jquery.searchable-1.0.0.min.js"></script>
    <script src="//code.jquery.com/jquery-1.11.1.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <script src="//netdna.bootstrapcdn.com/bootstrap/3.1.0/js/bootstrap.min.js"></script>
    <script src="https://kit.fontawesome.com/cbcfed9f1b.js" crossorigin="anonymous"></script>
    <title>Search weather!</title>
  </head>
  <body>
    <div class="container">
      <div class="row">
          <div class="col-lg-12">
              <div class="page-header">
                  <h1>Search weather</h1>
              </div>
               <h4>
                      {% if user.is_authenticated %}
                      Hello, {{ user.username }}!</br>
                      <a href="{% url 'logout' %}">Logout</a><br>
                    {% else %}
                     <p>You are not logged in</p>
                      <a href="{% url 'login' %}">Login Page</a>
                    {% endif %}
                  </h4>
          </div>
      </div>
<form method='POST' enctype="multipart/form-data">
      <div class="row">
          <div class="col-lg-4 col-lg-offset-4">

                {% csrf_token %}
                  <input required type="search" name="cityName"  class="form-control" placeholder="City Name">


          </div>
          <div class="col-lg-4 col-lg-offset-4">
            <button type="submit" class="btn btn-outline-primary">
              <i class="fas fa-search">GO</i>
              </button>
          </div>

      </div>

  </form>
      <br><br>
      <div class="row">
         <div class="col-lg-4 col-lg-offset-4 ">


          近五筆查詢資料：

         </div>

      </div>
      <div class="row">
         <div class="col-lg-4 col-lg-offset-4 ">
           <ul>cookie版本
                <li>
                  {{cookie0}}
                </li>
                 <li>
                  {{cookie1}}
                </li>
                <li>
                  {{cookie2}}
                </li>
                <li>
                  {{cookie3}}
                </li>
                <li>
                  {{cookie4}}
                </li>

             </ul>
         </div>
        <div class="col-lg-4 col-lg-offset-4 ">
           <ul>query版本
              {% for q in query%}
                <li>
                  {{q.cityName}}
                </li>
            {% endfor %}
             </ul>
         </div>
      </div>
      <br><br>
      <div class="row">
         <div class="col-lg-4 col-lg-offset-4">
          <button type="button" class="btn btn-outline-warning"
                      onclick="location.href='{% url 'door:weatherTable'%}';">

                    <i class="fas fa-chevron-circle-right">Result Table</i>
                      </button>
         </div>
      </div>
      <div class="row">
          <div class="col-lg-12">
              <table class="table table-striped" id="table">
                  <thead>
                      <tr>
                        <th>時間</th>
                        <th>溫度(°C)</th>
                        <th>國家</th>
                        <th>位置</th>
                        <th>天氣</th>
                      </tr>
                  </thead>
                  <tbody>
                      <tr>
                          <td>{{record.searchTime}}</td>
                          <td>{{record.degree}}</td>
                          <td>{{record.country}}</td>
                          <td>{{record.cityName}}</td>
                          <td>{{record.weather}}</td>
                      </tr>
                    </tbody>
                </table>
                <hr>
            </div>
        </div>
    </div>
     <script>
        {% if noResult%}
            alert("{{noResult}}")
        {% endif %}
    </script>

  </body>
</html>

weatherStation/door/templates/weatherTable.html
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="//rawgithub.com/stidges/jquery-searchable/master/dist/jquery.searchable-1.0.0.min.js"></script>
    <script src="//code.jquery.com/jquery-1.11.1.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <script src="//netdna.bootstrapcdn.com/bootstrap/3.1.0/js/bootstrap.min.js"></script>
      <script src="https://kit.fontawesome.com/cbcfed9f1b.js" crossorigin="anonymous"></script>
      <title>Show weather Records!</title>
  </head>
  <body>
      <div class="container">
        <div class="row">
            <div class="col-lg-12">
                <div class="page-header">
                    <h1>Show weather Records!</h1>
                </div>

            </div>
        </div>

        <br><br>
          <div class="row">
             <div class="col-lg-4 col-lg-offset-4">
              <button type="button" class="btn btn-outline-warning"
                          onclick="location.href='{% url 'door:index'%}';">
                    <i class="fas fa-chevron-circle-left">Search Weather</i>

                          </button>
             </div>
      </div>
        <div class="row">
            <div class="col-lg-12">
                <table class="table table-hover table-striped" id="mytable">
                    <thead>
                        <tr>
                          <th>時間

                                <!-- <button type="button" id="dialogSortUp" onclick="dialogSort()" class="btn btn-link btn-sm" style="display:block">
                                    <i class="fas fa-arrow-up"> 舊到新</i>
                                </button>
                                <button type="button" id="dialogSortDown"  onclick="dialogSort()" style="display:none" class="btn btn-link btn-sm">
                                    <i class="fas fa-arrow-down"> 新到舊</i>
                                </button>-->

                          </th>
                          <th>溫度(°C)</th>
                          <th>國家</th>
                          <th>位置</th>
                          <th>天氣</th>
                        </tr>
                    </thead>
                    <tbody>
                      {% for record in records %}
                        <tr>
                          <td>{{record.searchTime}}</td>
                          <td>{{record.degree}}</td>
                           <td>{{record.country}}</td>
                          <td>{{record.cityName}}</td>
                          <td>{{record.weather}}</td>
                        </tr>
                      {% endfor %}
                    </tbody>
                </table>
                <hr>
            </div>
        </div>
          <div class="row">
              <div class="col-lg-4 col-lg-offset-4">
                {% if records.has_other_pages %}
                      <ul class="pagination">
                        {% if records.has_previous %}
                          <li class="page-item"> <a class="page-link" href="?page={{ users.previous_page_number }}&amp;page={{ records.previous_page_number }}" aria-label="Previous">
                            <span aria-hidden="true">&laquo;</span>
                            <span class="sr-only">Previous</span>
                        </a>
                          {% else %}
                          <li class="page-item">
                            <a class="page-link" aria-label="Previous">
                                <span aria-hidden="true">&laquo;</span>
                                <span class="sr-only">Previous</span>
                            </a>
                         </li>
                        {% endif %}
                        {% for i in records.paginator.page_range %}
                          {% if records.number == i %}
                            <li class="active page-item">
                               <a class="page-link" >{{ i }} <span class="sr-only">(current)</span></a>
                            </li>
                          {% else %}
                            <li><a  href="?page={{ i }}" class="page-link" >{{ i }}</a></li>
                          {% endif %}
                        {% endfor %}
                        {% if records.has_next %}
                          <li class="page-item">
                            <a class="page-link" href="?page={{ records.next_page_number }}"  aria-label="Next">
                                <span aria-hidden="true">&raquo;</span>
                                <span class="sr-only">Next</span>
                            </a>
                          </li>
                        {% else %}
                          <li class="page-item"><a class="page-link" aria-label="Next">
                            <span aria-hidden="true">&raquo;</span>
                            <span class="sr-only">Next</span>
                        </a>
                          </li>
                        {% endif %}
                      </ul>
                {% endif %}


              </div>
          </div>

    </div>

    <script>
        up = document.getElementById("dialogSortUp")
        down = document.getElementById("dialogSortDown")
        var tmp = 1
        function reverseTableRows(tableId) {
            var table = document.getElementById (tableId);
            rows = table.rows
            for (var i = 1; i < rows.length; i++) {
                rows[i].parentNode.insertBefore(rows[rows.length-1], rows[i]);
            }
        }
        function dialogSort(){
           if(tmp == 0){
                up.style.display = "block"
                down.style.display = "none"
                tmp = 1
                var thead = $('mytable thead');
                thead.html($('tr',thead).get().reverse());
                reverseTableRows("mytable")
           }
           else if(tmp == 1){
                up.style.display = "none"
                down.style.display = "block"
                tmp = 0
                var thead = $('mytable thead');
                thead.html($('tr',thead).get().reverse());
                reverseTableRows("mytable")

           }
        }



    </script>

<script>
  window.fbAsyncInit = function() {
    FB.init({
      appId      : '{your-app-id}',
      cookie     : true,
      xfbml      : true,
      version    : '{api-version}'
    });

    FB.AppEvents.logPageView();

  };

  (function(d, s, id){
     var js, fjs = d.getElementsByTagName(s)[0];
     if (d.getElementById(id)) {return;}
     js = d.createElement(s); js.id = id;
     js.src = "https://connect.facebook.net/en_US/sdk.js";
     fjs.parentNode.insertBefore(js, fjs);
   }(document, 'script', 'facebook-jssdk'));
</script>
  </body>
</html>